package jsonutil;

#
# Author: papanda@papa.to
# License: 3-clause BSD license
#

use strict;
use CGI;
use JSON;
use DateTime;
use bytes ();

sub jsonutil::output {
    my ($q, $stat, $body, $contenttype, $expires) = @_;
    
    my $callback = $q->param('callback') || $q->param('cb') || '';
    if ($callback && $callback=~ m!^[\w]+$!) {
	$body = $callback . '(' . $body . ');';
    }
    my $length = bytes::length $body;

    if (!$contenttype) {
	# デフォルトはtext/json
	$contenttype = 'text/json';
    }
    if (!$expires) {
	# デフォルトは10分
	$expires = 600;
    }
    my $header = '';
    if ($q) {
	if ($stat >= 200 && $stat < 302) {
	    # キャッシュしてもらう
	    $header = $q->header(-type=>$contenttype, -status=>$stat, -charset=>'utf-8', -connection=>'close', -expires=>'+'.$expires.'s'); 
	} else {
	    # キャッシュ抑制
	    $header = $q->header(-type=>$contenttype, -status=>$stat, -charset=>'utf-8', -connection=>'close', -cachecontrol=>'no-cache', -pragma=>'no-cache', -expires=>'-1');
	    # mod_perlが常に200 OKを返してしまう対策
	    $| = 1;
	}
    }
    return $header . $body;
}

1;
