#
# Author: papanda@papa.to
# License: 3-clause BSD license
#

package wordutil;

use strict;
use DateTime;

$wordutil::wordbytemin = 2;

sub wordutil::htmlesc {
    my ($str) = @_;
    $$str =~ s!<[^>]*>!!g;
    $$str =~ s!<!&lt;!g;
    $$str =~ s!>!&gt;!g;
}

sub wordutil::ctrlesc {
    my ($str) = @_;
    &wordutil::htmlesc($str);
    $$str =~ s!\\[actn]!!g;
    $$str =~ s!\\r!<br>!g;
    $$str =~ s!\[[^\]]+\]!!g;
}

sub wordutil::ptime2pdate {
    my ($ptime) = @_;
    my $dt = DateTime->from_epoch( epoch=>$ptime, time_zone=>'local' );
    return sprintf("%04d%02d%02d", $dt->year, $dt->month, $dt->day);
}

1;
